require 'sketchup'

################################################################################
#    Cross-platform WebDialog True-modality workaround - Windows - Mac OSX     #
#        - www.SUalive.com shared code - FREE OF USE no liability -            #
#                Thanks to John - Driven - for his great help                  #
#      authors would appreciate a link to this topic or www.SUalive.com        #
# http://sketchucation.com/forums/viewtopic.php?f=180&t=65013&p=602971#p602971 #
#                              see also below                                  #
# http://sketchucation.com/forums/viewtopic.php?f=180&t=65013&start=30#p603466 #
################################################################################
# wait for WebDialog close then goes on next code
# 1 - dialog_box_run() method runs the dialog
# 2 - tmr_modal wait for user cliks on <Continue> or <Exit>
# 3 - tmr_modal calls dialog_box_is_closed()
################################################################################
#        Please note Mac-user can interact with the parent window wheras       #
#        Windows-user can't. So locking parent window is up to you             #
################################################################################

module YDco_debug
	module YDalv
	
		class << self
		
			@cli_dlg_debug = nil
			
			def dialog_box_run()
				@cli_dlg_debug = YDalv::Dlg_debug.new()
			end
			def dialog_box_is_closed()
				str_out = "  DlFg_debug returns <Continue> button cliqued? " + 
					@cli_dlg_debug.is_continue.to_s
				puts str_out
				UI.messagebox( str_out )
			end
			
		end
		
		class Dlg_debug < UI::WebDialog
		
			attr_reader :is_continue
		
			def initialize()
				@is_continue = false
				@is_closed = false
				super "SUalive debug", false, "SUalvDebug", 512, 256, 100, 50, false
				set_html(html_data)
				initialize_callback()
				set_on_close do
					@is_closed = true
				end
				true_modality_emulation_through_timer()
				show_modal()
			end
			
			private
			def html_data()
				str_html = '<html><head>' +
					'<meta http-equiv="content-type" content="charset=UTF-8">'+
					'<meta http-equiv="MSThemeCompatible" content="Yes">'+
					'<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">'+
					'<script type="text/JavaScript">'+
					'function jsDebugSwitch(obj){document.getElementById("btnContinue").disabled=!obj.checked}'+
					'function jsDebugToRuby(obj){var isOK=(obj.id=="btnContinue");window.location="skp:qwerty@"+isOK}'+
					'</script>'+
					'</head><body>' +
					'<div style="width: 496px; font-family: Arial">' +
					'<div style="border: solid 1px #CECECE; padding: 0px 10px 0px 10px; ' +
							'font-family: Arial; font-size: 14px; width: 470px; height: 150px; ' +
							'text-align: justify; overflow: auto">'+
					'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam gravida nunc metus, '+
					'id vulputate metus rutrum at. Curabitur et pretium arcu. Morbi vehicula arcu a nisl ' +
					'consequat, non vulputate ligula congue. Aenean sit amet orci nec leo cursus tempus. '+
					'Nulla facilisi. Mauris vestibulum elit magna, ut pellentesque enim tincidunt placerat. '+
					'Nunc volutpat varius maximus. Praesent bibendum convallis tellus ut fringilla. '+
					'Vestibulum dignissim lacinia sapien, sed porttitor justo dictum quis. Curabitur laoreet '+
					'nisl nunc. Ut egestas magna eget laoreet gravida. '+
					'</div>' +
					'<div style="width: 482px; margin: 20px 7px 0px 7px; font-size:smaller">' +
								'<div style="float: right">' +
									'<button id="btnContinue" style="margin-right: 7px" onclick="jsDebugToRuby(this)" disabled>Continue</button>' +
									'<button id="btnExit" onclick="jsDebugToRuby(this)">Exit</button>' +
								'</div>' +
								'<input type="checkbox" onclick="jsDebugSwitch(this)">Check me please' +
							'</div>' +
						'</div>' +
					'</body></html>'
				return str_html
			end
			def initialize_callback()
				add_action_callback("qwerty") do |wdialog, str_params|
					@is_continue = (str_params == "true")
					wdialog.close()
				end
			end
			
			def true_modality_emulation_through_timer()
				tmr_modal = UI.start_timer(0.3333, true) {				
					if @is_closed
						UI.stop_timer(tmr_modal)
						YDalv::dialog_box_is_closed()
					end
				}
			end
			
		end
		
		dialog_box_run()
		
	end
end